#!/bin/bash

ipv4="^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$"

getips() {
    if [[ $1 =~ $ipv4 ]]; then
        echo "$1"
    else
        for n in $(dig +short "$1") ; do
            if [[ $n =~ $ipv4 ]]; then
                echo "$n"
            fi
        done
    fi
}

jc=0
while getopts :cm OPT ; do
  case $OPT in
    c) jc=1 ;; # Just Contry name
    m) # My IP
        curl -s https://ipinfo.io/ip
        echo
        exit
        ;;
  esac
done
shift $((OPTIND - 1))

[ $# -lt 1 ] && echo "$0 [-mc] <public IP> ..." && exit 1
argc=$#

while [ -n "$1" ]; do
    if [ $argc -gt 1 -a $jc -eq 0 ]; then
        [[ ! $1 =~ $ipv4 ]] && echo "[$1]"
    fi
    for a in $(getips $1) ; do
        ip=0
        curl -s http://api.geoiplookup.net/?query=$a |
        while IFS=$'>' read -d '<' tag element ; do
            case "$tag" in
                "countryname" )
                    country="${element:--}"
                    [ $jc -eq 0 ] && echo "${tag}:${country}"
                    ;;
                "city" ) [ $jc -eq 0 ] && echo "${tag}:${element}" ;;
                "ip" ) 
                    [ "${ip}" -eq 0 ] && ip=1 && continue # top nodeのipは、スキップ
                    ip="${element}"
                    [ $jc -eq 0 ] && echo "${tag}:${element}"
                    ;;
                #* ) [ $jc -eq 0 ] && echo "${tag}:${element}" ;; その他の情報も表示する場合
            esac
            if [ $jc -eq 1 -a -n "${country}" ]; then
                if [[ "${ip}" =~ $ipv4 ]]; then
                    [ $argc -gt 1 ] && [[ ! $1 =~ $ipv4 ]] && echo -n "[$1]:"
                    echo "${ip}:${country}"
                    ip=1
                    country=""
                fi
            fi
        done
        [ $jc -eq 0 ] && echo
    done
    shift
done
